"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var buffer_1 = require("buffer");
var fileDownloader = function (data, filename, mime, bom) {
    var sources = typeof bom !== "undefined" ? [bom, data] : [data];
    var options = { type: mime || "application/octet-stream" };
    var blob = new buffer_1.Blob(sources, options);
    var url = window.URL && window.URL.createObjectURL
        ? window.URL.createObjectURL(blob)
        : window.webkitURL.createObjectURL(blob);
    var anchor = document.createElement("a");
    anchor.style.display = "none";
    anchor.href = url;
    anchor.setAttribute("download", filename);
    if (typeof anchor.download === "undefined") {
        anchor.setAttribute("target", "_blank");
    }
    document.body.appendChild(anchor);
    anchor.click();
    setTimeout(function () {
        document.body.removeChild(anchor);
        window.URL.revokeObjectURL(url);
    }, 100);
};
exports.default = fileDownloader;
